<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		version="1.0">
  <xsl:output method="text" indent="no"/>
  <xsl:strip-space elements="*" />

  <xsl:template name="print">
    <xsl:param name="version" />
    <xsl:param name="author" />
    <xsl:param name="email" />
    <xsl:param name="deb-date" />
    <xsl:param name="summary" />
    <xsl:text>tarot (</xsl:text><xsl:value-of select="$version" /><xsl:text>-1) UNRELEASED; urgency=medium&#xA;&#xA;  * </xsl:text><xsl:value-of select="normalize-space($summary)" /><xsl:text>&#xA;&#xA; -- </xsl:text><xsl:value-of select="$author" /><xsl:text> &lt;</xsl:text><xsl:value-of select="$email" /><xsl:text>&gt;  </xsl:text><xsl:value-of select="$date" /><xsl:text>&#xA;&#xA;</xsl:text>
  </xsl:template>

  <xsl:template match="releases">
    <xsl:if test="$snapshot = 'yes'">
      <xsl:call-template name="print">
	<xsl:with-param name="version" select="$version" />
	<xsl:with-param name="author" select="$author" />
	<xsl:with-param name="email" select="$email" />
	<xsl:with-param name="deb-date" select="$date" />
	<xsl:with-param name="summary">
	  Development snapshot
	</xsl:with-param>
      </xsl:call-template>
    </xsl:if>
    <xsl:apply-templates />
  </xsl:template>

  <xsl:template match="release">
    <xsl:call-template name="print">
      <xsl:with-param name="version" select="@version" />
      <xsl:with-param name="author" select="@author" />
      <xsl:with-param name="email" select="@email" />
      <xsl:with-param name="deb-date" select="@deb-date" />
      <xsl:with-param name="summary">
	<xsl:apply-templates select="summary" />
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="summary">
      <xsl:apply-templates />
  </xsl:template>
</xsl:stylesheet>
