<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		version="1.0">
  <xsl:output method="text" indent="no"/>
  <xsl:strip-space elements="*" />

  <xsl:template name="header">
    <xsl:text>/* Do not edit this file, it has been generated from gen-c-code.xsl */&#xA;</xsl:text>
  </xsl:template>

  <xsl:template match="tree">
    <xsl:call-template name="header" />
    <xsl:apply-templates />
  </xsl:template>

  <xsl:template name="print-split-condition">
    <xsl:param name="variable" />
    <xsl:param name="operator" />
    <xsl:param name="value" />
    <xsl:value-of select="translate($variable, '-', '_')" />
    <xsl:choose>
      <xsl:when test="$operator = '='">
	<xsl:text> == </xsl:text>
      </xsl:when>
      <xsl:otherwise>
	<xsl:value-of select="$operator" />
      </xsl:otherwise>
    </xsl:choose>
    <xsl:choose>
      <xsl:when test="contains($value, ',')">
	<xsl:value-of select="substring-before($value, ',')" />
	<xsl:text> || </xsl:text>
	<xsl:call-template name="print-split-condition">
	  <xsl:with-param name="variable" select="$variable" />
	  <xsl:with-param name="operator" select="$operator" />
	  <xsl:with-param name="value" select="substring-after($value, ',')" />
	</xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
	<xsl:value-of select="$value" />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="split">
    <xsl:text>if (</xsl:text>
    <xsl:call-template name="print-split-condition">
      <xsl:with-param name="variable" select="@variable" />
      <xsl:with-param name="operator" select="@operator" />
      <xsl:with-param name="value" select="@value" />
    </xsl:call-template>
    <xsl:text>) {score = </xsl:text>
    <xsl:value-of select="@score" />
    <xsl:text>; </xsl:text>
    <xsl:apply-templates />
    <xsl:text>}</xsl:text>
  </xsl:template>

  <!-- Write the linear prediction -->
  <xsl:template match="linear-model">
    <xsl:call-template name="header" />
    <xsl:text>score = (0</xsl:text>
    <xsl:apply-templates />
    <xsl:text>);</xsl:text>
  </xsl:template>

  <xsl:template match="interaction">
    <xsl:text>+</xsl:text>
    <xsl:value-of select="@weight" />
    <xsl:text>*(1</xsl:text>
    <xsl:apply-templates />
    <xsl:text>)</xsl:text>
  </xsl:template>

  <xsl:template match="variable[@name != '(Intercept)']">
    <xsl:text>* </xsl:text>
    <xsl:value-of select="translate(@name, '-', '_')" />
  </xsl:template>

  <xsl:template match="variable[contains(@name, '_eq_')]">
    <xsl:text>* (</xsl:text>
    <xsl:value-of select="substring-before(@name, '_eq_')" />
    <xsl:text> == </xsl:text>
    <xsl:value-of select="substring-after(@name, '_eq_')" />
    <xsl:text>)</xsl:text>
  </xsl:template>

  <xsl:template match="variable[contains(@name, '_leq_')]">
    <xsl:text>* (</xsl:text>
    <xsl:value-of select="substring-before(@name, '_leq_')" />
    <xsl:text> &lt;= </xsl:text>
    <xsl:value-of select="substring-after(@name, '_leq_')" />
    <xsl:text>)</xsl:text>
  </xsl:template>
</xsl:stylesheet>
